searchNodes=[{"doc":"Functions and features to help Elixir applications more easily take advantage of the features that Fly.io provides.","ref":"Fly.html","title":"Fly","type":"module"},{"doc":"Return if the app instance is running in the primary region or not. Boolean result.","ref":"Fly.html#is_primary?/0","title":"Fly.is_primary?/0","type":"function"},{"doc":"Return the configured current region. Reads the FLY_REGION ENV setting that's available when deployed on the Fly.io platform.","ref":"Fly.html#my_region/0","title":"Fly.my_region/0","type":"function"},{"doc":"Return the configured primary region. Reads and requires an ENV setting for PRIMARY_REGION .","ref":"Fly.html#primary_region/0","title":"Fly.primary_region/0","type":"function"},{"doc":"Provides an RPC interface for executing an MFA on a node within a region. Configuration Assumes each node is running the Fly.RPC server in its supervision tree and exports FLY_REGION environment variable to identify the fly region. To run code on a specific region call rpc_region/4 . A node found within the given region will be chosen at random. Raises if no nodes exist on the given region. The special :primary region may be passed to run the rpc against the region identified by the PRIMARY_REGION environment variable. Examples &gt; rpc_region ( &quot;hkg&quot; , String , :upcase , [ &quot;fly&quot; ] ) &quot;FLY&quot; &gt; rpc_region ( Fly . primary_region ( ) , String , :upcase , [ &quot;fly&quot; ] ) &quot;FLY&quot; &gt; rpc_region ( :primary , String , :upcase , [ &quot;fly&quot; ] ) &quot;FLY&quot; Server The GenServer's responsibility is just to monitor other nodes as they enter and leave the cluster. It maintains a list of nodes and the Fly.io region where they are deployed in an ETS table that other processes can use to find and initiate their own RPC calls to.","ref":"Fly.RPC.html","title":"Fly.RPC","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Fly.RPC.html#child_spec/1","title":"Fly.RPC.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.handle_continue/2 .","ref":"Fly.RPC.html#handle_continue/2","title":"Fly.RPC.handle_continue/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Fly.RPC.html#init/1","title":"Fly.RPC.init/1","type":"function"},{"doc":"Executes a function on the remote node to determine if the RPC API support is available. Support may not exist on the remote node in a &quot;first roll out&quot; scenario.","ref":"Fly.RPC.html#is_rpc_supported?/1","title":"Fly.RPC.is_rpc_supported?/1","type":"function"},{"doc":"Asks a node what Fly region it's running in. Does this through an RPC call. If the function for asking isn't supported (code not running there yet), return an :error .","ref":"Fly.RPC.html#region/1","title":"Fly.RPC.region/1","type":"function"},{"doc":"Returns the Elixir OTP nodes registered the region. Reads from a local cache.","ref":"Fly.RPC.html#region_nodes/2","title":"Fly.RPC.region_nodes/2","type":"function"},{"doc":"Executes the function on the remote node and waits for the response up to timeout length.","ref":"Fly.RPC.html#rpc/5","title":"Fly.RPC.rpc/5","type":"function"},{"doc":"","ref":"Fly.RPC.html#rpc_region/5","title":"Fly.RPC.rpc_region/5","type":"function"},{"doc":"","ref":"Fly.RPC.html#start_link/1","title":"Fly.RPC.start_link/1","type":"function"},{"doc":"Fly RPC Helps a clustered Elixir application know what Fly.io region it is deployed in, if that is the primary region, and provides features for executing a function through RPC (Remote Procedure Call) on another node by specifying the region to run it in. Online Documentation","ref":"readme.html","title":"Fly RPC","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding fly_rpc to your list of dependencies in mix.exs : def deps do [ { :fly_rpc , &quot;~&gt; 0.1.0&quot; } ] end Through ENV configuration, you can to tell the app which region is the &quot;primary&quot; region. fly.toml This example configuration says that the Sydney Australia region is the &quot;primary&quot; region. [env] PRIMARY_REGION = &quot;syd&quot; Add Fly.RPC to your application's supervision tree. defmodule MyApp.Application do use Application def start ( _type , _args ) do # ... children = [ # Start the RPC server { Fly.RPC , [ ] } , #... ] # ... end end This starts a GenServer that reaches out to other nodes in the cluster to learn what Fly.io regions they are located in. The GenServer caches those results in a local ETS table for fast access.","ref":"readme.html#installation","title":"Fly RPC - Installation","type":"extras"},{"doc":"The Fly.io platform already provides and ENV value of FLY_REGION which this library accesses. Fly . primary_region ( ) #=&gt; &quot;syd&quot; Fly . current_region ( ) #=&gt; &quot;lax&quot; Fly . is_primary? ( ) #=&gt; false The real benefit comes in using the Fly.RPC module. Fly.RPC . rpc_region ( &quot;hkg&quot; , String , :upcase , [ &quot;fly&quot; ] ) #=&gt; &quot;FLY&quot; Fly.RPC . rpc_region ( Fly . primary_region ( ) , String , :upcase , [ &quot;fly&quot; ] ) #=&gt; &quot;FLY&quot; Fly.RPC . rpc_region ( :primary , String , :upcase , [ &quot;fly&quot; ] ) #=&gt; &quot;FLY&quot; Underneath the call, it's using Node.spawn_link/4 . This spawns a new process on a node in the desired region. Normally, that spawn becomes an asynchronous process and what you get back is a pid . In this case, the call executes on the other node and the caller is blocked until the result is received or the request times out. By blocking the process, this makes it much easier to reason about your application code.","ref":"readme.html#usage","title":"Fly RPC - Usage","type":"extras"},{"doc":"[ ] Instrument with telemetry","ref":"readme.html#features","title":"Fly RPC - Features","type":"extras"}]